﻿using System;
using Wisej.Web;

using Library.Rapport.Samling;
//using SeekProject.Search;
//using SeekProject;

namespace MGRptWebWisej.RapportKategoriForm
{
    public partial class RapportKategoriWindow : Form
    {

        //EditState mEState = EditState.EState_NoObject;

        RapportKategoriList mRapportKategoriList = RapportKategoriList.NewRapportKategoriList();
        RapportKategori mRapportKategori;

        //SearchObj SO = null;

        #region " Form "

        public RapportKategoriWindow()
        {
            InitializeComponent();

            if (DesignMode == false)
            {
                UpdateControls();
            }
        }

        private void RapportKategoriWindow_Load(object sender, EventArgs e)
        {
            try
            {
                RapportKategoriListBindingSource.DataSource = mRapportKategoriList;
                //RapportKategoriListBindingSource.DataSource = new MyCSLA.MySortableBindingList<RapportKategoriInfo>(mRapportKategoriList);
                UpdateControls();
            }
            catch (Exception ex)
            {
                //ErrorLog.Errormessage(ex, "Feil under åpning av vindu");
            }

            try
            {
                //SettingsForWindow.RestoreSettings(this, new object[] { splitContainerMain });
                //WindowsRutiner.AdjustFormPosition(this);
            }
            catch (Exception ex)
            {
                //ErrorLog.Errormessage(ex, "Feil under åpning av vindu");
            }
        }

        private void RapportKategoriWindow_FormClosing(object sender, FormClosingEventArgs e)
        {
            try
            {
                //SettingsForWindow.SaveSettings(this, new object[] { splitContainerMain });
            }
            catch (Exception ex)
            {
                //ErrorLog.Errormessage(ex);
            }
        }

        #endregion

        #region " Binding events "

        private void RapportKategoriListBindingSource_CurrentItemChanged(object sender, EventArgs e)
        {
            try
            {
                if (dataGridViewRapportKategoriList.Enabled)
                {
                    using (new NetForms.CursorKeeper(Cursors.WaitCursor))
                    {
                        GetSelectet();
                    }
                }
            }
            catch (Exception ex)
            {
                throw;
                //ErrorLog.Errormessage(ex);
            }
            finally
            {
                dataGridViewRapportKategoriList.Enabled = true;
            }
        }

        #endregion

        #region " Toolbar click "

        private void ToolStrip_ButtonClick(object sender, ToolBarButtonClickEventArgs e)
        {
            if (e.Button.Name == "TSNew")
            {
                TSNew_Click();
            }
            else if (e.Button.Name == "TSUpdate")
            {
                TSUpdate_Click();
            }
            else if (e.Button.Name == "TSDelete")
            {
                TSDelete_Click();
            }
            else if (e.Button.Name == "toolBarButtonSok")
            {
                toolBarButtonSok_Click();
            }
            else if (e.Button.Name == "toolBarButtonRefresh")
            {
                toolBarButtonRefresh_Click();

            }
            else if (e.Button.Name == "toolBarButtonLogg")
            {
                toolBarButtonLogg_Click();
            }
            else if (e.Button.Name == "TSSave")
            {
                TSSave_Click();
            }
            else if (e.Button.Name == "TSCancel")
            {
                TSCancel_Click();
            }
        }

        void TSCancel_Click()
        {
            try
            {
                using (new NetForms.CursorKeeper(Cursors.WaitCursor))
                {
                    mRapportKategori.CancelEdit();

                    GetSelectet();
                }
            }
            catch (Exception ex)
            {
                //ErrorLog.Errormessage(ex);
            }
            finally
            {
            }
        }

        void TSSave_Click()
        {
        }

        void TSNew_Click()
        {
        }

        void TSUpdate_Click()
        {
        }

        void TSDelete_Click()
        {
        }

        void toolBarButtonSok_Click()
        {
            try
            {
                //SearchObj mySO = Library.Rapport.Samling.RapportKategoriList.GetSeekObj();

                //if (Soek.Start(mySO, "Søk"))
                //{
                //    using (new NetForms.CursorKeeper(Cursors.WaitCursor))
                //    {
                //        SO = mySO;
                //        mRapportKategoriList = RapportKategoriList.GetRapportKategoriList(SO);
                //        //RapportKategoriListBindingSource.DataSource = new MyCSLA.MySortableBindingList<RapportKategoriInfo>(mRapportKategoriList);
                //        RapportKategoriListBindingSource.DataSource = mRapportKategoriList;
                //        if (mRapportKategoriList.Count == 0)
                //        {
                //            GetSelectet();
                //        }
                //    }
                //}
                mRapportKategoriList = RapportKategoriList.GetRapportKategoriList();
                RapportKategoriListBindingSource.DataSource = mRapportKategoriList;
            }
            catch (Exception ex)
            {
                //ErrorLog.Errormessage(ex);
            }
            finally
            {
            }
        }

        void toolBarButtonRefresh_Click()
        {
        }

        void toolBarButtonLogg_Click()
        {
        }

        #endregion

        #region " Rutiner "

        private void GetSelectet()
        {
            {

                if(RapportKategoriListBindingSource.Current != null)
                {
                    RapportKategoriInfo RapportKategoriInfo = (RapportKategoriInfo)RapportKategoriListBindingSource.Current;

                    mRapportKategori = RapportKategori.GetRapportKategori(RapportKategoriInfo.RAKRec);

                    this.RapportKategoriBindingSource.DataSource = mRapportKategori;
                    //mEState = EditState.EState_LoadedObject;
                    UpdateControls();
                }
                else
                {
                    if ((mRapportKategori != null))
                    {
                        // cancel changes in memory
                        this.RapportKategoriBindingSource.CancelEdit();
                        this.RapportKategoriBindingSource.Clear();
                        mRapportKategori = null;
                    }
                    //mEState = EditState.EState_NoObject;
                    UpdateControls();
                }
            }
        }

        private void AktiverToolbuttons(string TagValue)
        {
            foreach (ToolBarButton button in ToolStrip.Buttons)
            {
                if (button.Tag.ToString() == TagValue)
                {
                    button.Visible = true;
                }
                else
                {
                    button.Visible = false;
                }
            }
        }

        private void UpdateControls()
        {
            try
            {
                //bool isEditing = mEState == EditState.EState_EditingObject | mEState == EditState.EState_NewObject;

                if (mRapportKategori == null)
                {
                    //mEState = EditState.EState_NoObject;
                }

               // WindowsRutiner.SetControlsState(this.Controls, mEState);

                //this.ReadWriteAuthorization1.ResetControlAuthorization();

            }
            catch //(Exception ex)
            {
                throw;
            }
            finally
            {
            }
        }

        private void SaveProject(bool rebind)
        {
            Exception tex = null;

            // stop the flow of events
            this.RapportKategoriBindingSource.RaiseListChangedEvents = false;
            // apply changes in memory
            this.RapportKategoriBindingSource.EndEdit();
            // do the save
            try
            {
                // clone the object
                //RapportKategori temp = mRapportKategori.Clone;
                //mRapportKategori = temp.Save;

                mRapportKategori = mRapportKategori.Save();

                if (rebind)
                {
                    // rebind the UI
                    this.RapportKategoriBindingSource.DataSource = null;
                    this.RapportKategoriBindingSource.DataSource = mRapportKategori;
                    // check authorization
                    //ApplyAuthorizationRules();
                }

            }
            catch (Csla.DataPortalException ex)
            {
                //MessageBox.Show(ex.BusinessException.ToString, "Error saving", MessageBoxButtons.OK, MessageBoxIcon.Error)
                tex = ex;
            }
            catch (Csla.Rules.ValidationException ex)
            {
                //MessageBox.Show(ex.Message, "Error saving", MessageBoxButtons.OK, MessageBoxIcon.Error)
                tex = ex;
            }
            catch (Exception ex)
            {
                //MessageBox.Show(ex.ToString, "Error saving", MessageBoxButtons.OK, MessageBoxIcon.Error)
                tex = ex;
            }
            finally
            {
                // restore events
                this.RapportKategoriBindingSource.RaiseListChangedEvents = true;
                // refresh the UI
                this.RapportKategoriBindingSource.ResetBindings(false);

                UpdateControls();
                if ((tex != null))
                {
                    throw tex;
                }
            }

        }

        #endregion

    }
}
